package com.usky.dxtop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.usky.dxtop.common.core.page.CommonPage;
import com.usky.dxtop.common.utils.StringUtils;
import com.usky.dxtop.mapper.ChargeMapper;
import com.usky.dxtop.model.Charge;
import com.usky.dxtop.service.ChargeService;
import com.usky.dxtop.service.vo.ChargeRequest;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author yq
 * @since 2021-09-09
 */
@Service
public class ChargeServiceImpl extends ServiceImpl<ChargeMapper, Charge> implements ChargeService {

    @Override
    public CommonPage<Charge> page(ChargeRequest chargeRequest) {
        //TODO 后面需要改成和user表的join操作
        IPage<Charge> page = new Page<>(chargeRequest.getCurrent(), chargeRequest.getSize());
        LambdaQueryWrapper<Charge> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper
                .like(StringUtils.isNotBlank(chargeRequest.getCart()),Charge::getCard,chargeRequest.getCart())
                .between(null != chargeRequest.getStartTime() && null != chargeRequest.getEndTime(),
                        Charge::getCreateTime,chargeRequest.getStartTime(),chargeRequest.getEndTime())
                .orderByDesc(Charge::getCreateTime);
        page = this.page(page, queryWrapper);
        return new CommonPage<>(page.getRecords(),page.getTotal(),page.getCurrent(),page.getSize());
    }

    @Override
    public Charge one(Long seq) {
        return this.getById(seq);
    }
}
